## oneclient-base 21.02.8.58.g49d5da0

=== debian/changelog ===
oneclient-base (21.02.8.58.g49d5da0-1~focal) focal; urgency=low

  * Build from 21.02.8.58.g49d5da0

 -- Onedata Package Maintainer <support@onedata.org>  Fri, 24 Oct 2025 20:02:16 +0200
