## oneclient-base 21.02.8.63.g20cd0af

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,10 @@
 endif()
 
 project(oneclient C CXX)
+
+set(CMAKE_CXX_STANDARD 17)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
+set(CMAKE_CXX_EXTENSIONS OFF)
 
 option(CODE_COVERAGE "Enable code coverage (gcc only)." OFF)
 option(STATIC_BOOST "Link Boost statically" OFF)
@@ -162,7 +166,7 @@
         GIT_REPOSITORY    https://github.com/facebook/folly.git
         GIT_TAG           v2024.06.24.00
         INSTALL_DIR       ${CMAKE_BINARY_DIR}/contrib
-        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC';-DBUILD_TESTS=OFF;-DCMAKE_C_FLAGS='-Wl,-lrt';-DCMAKE_EXE_LINKER_FLAGS='-lrt';-DCMAKE_EXE_LINKER_FLAGS='-lrt';-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib"
+        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC -Wno-address';-DBUILD_TESTS=OFF;-DCMAKE_C_FLAGS='-Wl,-lrt';-DCMAKE_EXE_LINKER_FLAGS='-lrt';-DCMAKE_EXE_LINKER_FLAGS='-lrt';-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib"
     )
     ExternalProject_Add_StepTargets(folly install)
     ExternalProject_Add(fizz
@@ -171,7 +175,7 @@
         SOURCE_SUBDIR     fizz
         DEPENDS           folly-install
         INSTALL_DIR       ${CMAKE_BINARY_DIR}/contrib
-        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC';-DBUILD_TESTS=OFF;-DCMAKE_PREFIX_PATH=${CMAKE_BINARY_DIR}/contrib;-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib"
+        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC -Wno-address';-DBUILD_TESTS=OFF;-DCMAKE_PREFIX_PATH=${CMAKE_BINARY_DIR}/contrib;-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib"
     )
     ExternalProject_Add_StepTargets(fizz install)
     ExternalProject_Add(wangle
@@ -180,7 +184,7 @@
         SOURCE_SUBDIR     wangle
         DEPENDS           fizz-install
         INSTALL_DIR       ${CMAKE_BINARY_DIR}/contrib
-        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC';-DBUILD_TESTS=OFF;-DCMAKE_PREFIX_PATH=${CMAKE_BINARY_DIR}/contrib;-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib"
+        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC -Wno-address';-DCMAKE_PREFIX_PATH=${CMAKE_BINARY_DIR}/contrib;-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib;-DBUILD_TESTS=OFF;-DBUILD_EXAMPLES=OFF;-DCMAKE_CROSSCOMPILING=ON"
     )
     ExternalProject_Add_StepTargets(wangle install)
     ExternalProject_Add(mvfst
@@ -188,7 +192,7 @@
         GIT_TAG           v2024.06.24.00
         DEPENDS           wangle-install
         INSTALL_DIR       ${CMAKE_BINARY_DIR}/contrib
-        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC';-DBUILD_TESTS=OFF;-DCMAKE_PREFIX_PATH=${CMAKE_BINARY_DIR}/contrib;-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib"
+        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC -Wno-address';-DBUILD_TESTS=OFF;-DCMAKE_PREFIX_PATH=${CMAKE_BINARY_DIR}/contrib;-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib"
     )
     ExternalProject_Add_StepTargets(mvfst install)
     ExternalProject_Add(proxygen
@@ -196,17 +200,59 @@
         GIT_TAG           v2024.06.24.00
         DEPENDS           mvfst-install
         INSTALL_DIR       ${CMAKE_BINARY_DIR}/contrib
-        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC';-DBUILD_TESTS=OFF;-DCMAKE_PREFIX_PATH=${CMAKE_BINARY_DIR}/contrib;-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib"
+        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC -Wno-address';-DBUILD_TESTS=OFF;-DCMAKE_PREFIX_PATH=${CMAKE_BINARY_DIR}/contrib;-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib"
     )
     ExternalProject_Add_StepTargets(proxygen install)
     set(FOLLY_INCLUDE_DIR ${CMAKE_BINARY_DIR}/contrib/include)
     set(FOLLY_LIBRARIES
+        ${CMAKE_BINARY_DIR}/contrib/lib/libwangle.a
         ${CMAKE_BINARY_DIR}/contrib/lib/libfolly.a
         ${CMAKE_BINARY_DIR}/contrib/lib/libfollybenchmark.a
         ${CMAKE_BINARY_DIR}/contrib/lib/libwangle.a
         ${LIBEVENT_LIBRARY}
         ${IBERTY_LIBRARY}
         ${CMAKE_BINARY_DIR}/contrib/lib/libfizz.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_async_udp_socket.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_batch_writer.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_buf_accessor.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_bufutil.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_cc_algo.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_client.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_codec.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_codec_decode.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_codec_packet_number_cipher.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_codec_pktbuilder.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_codec_pktrebuilder.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_codec_types.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_constants.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_dsr_frontend.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_dsr_types.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_events.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_exception.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_fizz_client.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_fizz_handshake.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_flowcontrol.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_handshake.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_happyeyeballs.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_looper.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_loss.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_observer.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_qlogger.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_server.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_server_async_tran.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_server_state.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_state_ack_handler.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_state_datagram_handler.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_state_functions.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_state_machine.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_state_pacing_functions.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_state_simple_frame_functions.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_state_stream.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_state_stream_functions.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_transport.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_transport_knobs.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_transport_settings_functions.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_xsk.a
         ${CMAKE_BINARY_DIR}/contrib/lib/libproxygen.a
         ${DOUBLE_CONVERSION_LIBRARY}
         gflags
@@ -234,96 +280,3 @@
 endif(WITH_PYTHON2)
 
 if(WITH_PYTHON3)
-  find_package(Python3)
-endif(WITH_PYTHON3)
-
-# Setup helpers
-set(HELPERS_DIR ${CMAKE_CURRENT_SOURCE_DIR}/helpers)
-
-# Setup Asio
-set(ASIO_INCLUDE_DIRS ${HELPERS_DIR}/deps/asio/asio/include)
-# Setup cppmetrics
-set(CPPMETRICS_INCLUDE_DIRS ${HELPERS_DIR}/deps/cppmetrics)
-# Setup backward-cpp
-set(BACKWARD_CPP_INCLUDE_DIRS ${HELPERS_DIR}/deps/backward-cpp)
-
-# Setup spdlog and fmt
-if(FOLLY_SHARED)
-    find_library(FMT_LIBRARY NAMES libfmt.a fmt REQUIRED)
-    find_library(SPDLOG_LIBRARY NAMES libspdlog.a spdlog REQUIRED)
-    add_definitions(-DSPDLOG_COMPILED_LIB -DSPDLOG_FMT_EXTERNAL)
-else(FOLLY_SHARED)
-    find_library(FMT_LIBRARY NAMES fmt libfmt.a REQUIRED)
-    find_library(SPDLOG_LIBRARY NAMES spdlog libspdlog.a REQUIRED)
-endif(FOLLY_SHARED)
-
-# Utility libs
-find_library(LTDL_LIBRARY NAMES ltdl)
-find_package(ZLIB)
-
-if(WITH_LIBRT)
-find_library(RT_LIBRARY rt)
-endif(WITH_LIBRT)
-
-if(WITH_LIBDL)
-find_library(DL_LIBRARY dl)
-endif(WITH_LIBDL)
-
-# Rados library
-if(WITH_CEPH)
-    find_library(CEPHCOMMON_LIBRARY "ceph-common" NAMES "ceph-common" "libceph-common.so.2" "libceph-common.so.0" PATH_SUFFIXES "ceph")
-    find_library(RADOS_LIBRARY rados)
-    find_library(RADOSSTRIPER_LIBRARY radosstriper)
-    get_filename_component(CEPHCOMMON_RPATH "${CEPHCOMMON_LIBRARY}" DIRECTORY)
-endif(WITH_CEPH)
-
-# AWS SDK library
-if(WITH_S3)
-    find_package(AWSSDK REQUIRED COMPONENTS s3)
-    set(AWS_SDK_LIBRARIES
-        ${AWSSDK_LINK_LIBRARIES}
-        ${AWSSDK_PLATFORM_DEPS}
-        ${CURL_LIBRARIES})
-    add_definitions(-DWITH_S3=1)
-    if(APPLE)
-      add_definitions(-DS3_HAS_NO_V2_SUPPORT)
-    endif(APPLE)
-else(WITH_S3)
-    add_definitions(-DWITH_S3=0)
-endif(WITH_S3)
-
-# Swift SDK library
-if(WITH_SWIFT)
-    find_library(SWIFT_SDK_LIBRARY Swift)
-    find_library(POCO_UTIL PocoUtil)
-    find_library(POCO_NET PocoNet)
-    find_library(POCO_XML PocoXML)
-    find_library(POCO_FOUNDATION PocoFoundation)
-    set(SWIFT_SDK_LIBRARIES
-        ${SWIFT_SDK_LIBRARY}
-        ${POCO_UTIL}
-        ${POCO_NET}
-        ${POCO_XML}
-        ${POCO_FOUNDATION})
-endif(WITH_SWIFT)
-
-# GlusterFS SDK library
-if(WITH_GLUSTERFS)
-    include(FindPkgConfig)
-    if (PKG_CONFIG_FOUND)
-        set(ENV{PKG_CONFIG_PATH} "/opt/oneclient/lib/x86_64-linux-gnu/pkgconfig:$ENV{PKG_CONFIG_PATH}")
-        pkg_check_modules(GLUSTERFSAPI glusterfs-api>=6.0)
-        if(NOT GLUSTERFSAPI_FOUND EQUAL 1)
-            message(SEND_ERROR "pkg-config for glusterfs-api is missing.")
-        else()
-            add_definitions(-DWITH_GLUSTERFS=1)
-            link_directories(${GLUSTERFSAPI_LIBDIR})
-	    message(STATUS "GLUSTERFSAPI_LIBDIR=${GLUSTERFSAPI_LIBDIR}")
-	    message(STATUS "GLUSTERFSAPI_LIBRARIES=${GLUSTERFSAPI_LIBRARIES}")
-	    message(STATUS "GLUSTERFSAPI_LINK_LIBRARIES=${GLUSTERFSAPI_LINK_LIBRARIES}")
-        endif()
-    endif (PKG_CONFIG_FOUND)
-else(WITH_GLUSTERFS)
-    add_definitions(-DWITH_GLUSTERFS=0)
-endif(WITH_GLUSTERFS)
-
