## oneclient-base 21.02.8.112.g4b04e35

=== debian/changelog ===
oneclient-base (21.02.8.112.g4b04e35-1~focal) focal; urgency=low

  * Build from 21.02.8.112.g4b04e35

 -- Onedata Package Maintainer <support@onedata.org>  Fri, 25 Apr 2025 11:42:02 +0200
