## oneclient-base 21.02.8.137.gfe9c93a

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -8,4 +8,7 @@
 endif()
 
 add_subdirectory(unit)
+
+if(WITH_BENCHMARKS)
 add_subdirectory(benchmark)
+endif(WITH_BENCHMARKS)
