=== debian/control ===
Source: oneclient-base
Section: net
Priority: optional
Maintainer: Onedata Package Maintainer <support@onedata.org>
Build-Depends:
    aws-sdk-cpp-s3 (>= 1.8.7),
    cmake (>= 3.0.0),
    debhelper (>= 9),
    folly-dev,
    g++ (>= 9.4.0),
    git,
    glusterfs-common (>= 7.2),
    libglusterfs-dev (>= 7.2),
    golang-go,
    libacl1-dev,
    libboost-all-dev,
    libcurl4-openssl-dev,
    libdouble-conversion-dev,
    libfuse3-dev (>= 3.6),
    libgoogle-glog-dev (>= 0.3.4),
    libiberty-dev,
    libjsoncpp-dev,
    libltdl-dev,
    libnspr4-dev,
    libnss3-dev,
    libprotobuf-dev (>= 3.4.1),
    libradospp-dev (>= 15.2.0),
    libradosstriper-dev (>= 15.2.0),
    libsodium-dev,
    libssl-dev (>= 1.1.0),
    libstdc++-9-dev,
    libtbb-dev,
    libpoco-dev,
    libpocofoundation62,
    libpoconetssl62,
    libpocoutil62,
    libpocoxml62,
    libxrootd-client-dev,
    libxrootd-server-dev,
    libxrootd-private-dev,
    openssl (>= 1.1.0),
    pkg-config,
    protobuf-compiler (>= 3.4.1),
    python3-dev,
    subversion,
    libunwind-dev,
    uuid-dev,
    wangle-dev,
    proxygen-dev,
    libfmt-dev (>= 7.0.1),
    libspdlog-dev (>= 1:1.7.0),
    libnfs-dev (>= 4.0.0)
Standards-Version: 3.9.5
Homepage: https://onedata.org

Package: oneclient-base
Architecture: amd64
Depends: glusterfs-common (>= 7.2), libnfs13 (>= 4.0.0), folly, libxrootd-client-dev, xrootd-plugins, xrootd-client-plugins, ${shlibs:Depends}, ${misc:Depends}, fuse3, libunwind8
Description: FUSE client for onedata system.
 Oneclient is a software based on FUSE (Filesystem in Userspace) that allows
 mounting onedata filesystem on Linux systems.

Package: python3-onedatafs
Architecture: amd64
Depends: python3, libboost-python1.71.0, libnfs13 (>= 4.0.0), folly, libxrootd-client-dev, xrootd-plugins, xrootd-client-plugins, libunwind8, ${shlibs:Depends}, ${misc:Depends}
Description: FUSE client for onedata system.
 oneclient is a software based on FUSE (Filesystem in Userspace) that allows
 mounting onedata filesystem on Linux systems.
