## oneclient-base 21.02.8.142.gc9ccaf8

=== debian/changelog ===
oneclient-base (21.02.8.142.gc9ccaf8-1~focal) focal; urgency=low

  * Build from 21.02.8.142.gc9ccaf8

 -- Onedata Package Maintainer <support@onedata.org>  Fri, 04 Jul 2025 17:09:54 +0200
