=== debian/changelog ===
oneclient-base (21.02.8.154.g1e69cff-1~focal) focal; urgency=low

  * Build from 21.02.8.154.g1e69cff

 -- Onedata Package Maintainer <support@onedata.org>  Tue, 26 Aug 2025 16:35:48 +0200
