## oneclient-base 21.02.8.158.g1f1a15d

=== debian/changelog ===
oneclient-base (21.02.8.158.g1f1a15d-1~focal) focal; urgency=low

  * Build from 21.02.8.158.g1f1a15d

 -- Onedata Package Maintainer <support@onedata.org>  Wed, 27 Aug 2025 10:35:42 +0200
